function [upperFunctionValue upperEqualityConstrVals upperInequalityConstrVals]=ulTestProblem(upperLevelMember, lowerLevelMember, testProblemName)
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Function call here
    fhandle = str2func(testProblemName);

    equalityConstrVals = [];
    inequalityConstrVals = [];
    
    [upperFunctionValue upperEqualityConstrVals upperInequalityConstrVals] = fhandle(upperLevelMember, lowerLevelMember);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
function [functionValue equalityConstrVals inequalityConstrVals] = tp1(xu, xl)

    %At optima xu1=20,xu2=5,xl1=10,xl2=5,fu=-225
    functionValue = (xu(1)-30).^2 + (xu(2)-20).^2 - 20*xl(1) + 20*xl(2);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Write the constraints here
    equalityConstrVals = [];
    inequalityConstrVals(1) = 30 - xu(1) - 2*xu(2);
    inequalityConstrVals(2) = xu(1) + xu(2) - 25;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
function [functionValue equalityConstrVals inequalityConstrVals] = tp2(xu, xl)

    %At optima x1=0,x2=30,y1=-10,xl2=10,fu=0,fl=-100
    x1 = xu(1);
    x2 = xu(2);
    y1 = xl(1);
    y2 = xl(2);
    functionValue = 2*x1+2*x2-3*y1-3*y2-60;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Write the constraints here
    equalityConstrVals = [];
    inequalityConstrVals(1) = x1+x2+y1-2*y2-40;
    %Lower level constraints included at upper level
    inequalityConstrVals(2) = 10-x1+2*y1;
    inequalityConstrVals(3) = 10-x2+2*y2;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
function [functionValue equalityConstrVals inequalityConstrVals] = tp3(xu, xl)

    %At optima x1=0,x2=2,y1=1.8750,xl2=0.9062,fu=18.6787,fl=1.0156
    x1 = xu(1);
    x2 = xu(2);
    y1 = xl(1);
    y2 = xl(2);
    functionValue = -x1.^2-3*x2.^2-4*y1+y2.^2;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Write the constraints here
    equalityConstrVals = [];
    inequalityConstrVals(1) = x1.^2+2*x2-4;
    %Lower level constraints included at upper level
    inequalityConstrVals(2) = -3-x1.^2+2*x1-x2.^2+2*y1-y2;
    inequalityConstrVals(3) = 4-x2-3*y1+4*y2;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
function [functionValue equalityConstrVals inequalityConstrVals] = tp4(xu, xl)

    %At optima x1=0.29,x2=0.70,y1=0,y2=0.27,y3=0.27,fu=29.2,fl=-3.2
    x1 = xu(1);
    x2 = xu(2);
    y1 = xl(1);
    y2 = xl(2);
    y3 = xl(3);
    functionValue = -8*x1-4*x2+4*y1-40*y2-4*y3;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Write the constraints here
    equalityConstrVals = [];
    %inequalityConstrVals = [];
    %Lower level constraints included at upper level
    inequalityConstrVals(1) = y2+y3-y1-1;
    inequalityConstrVals(2) = 2*x1-y1+2*y2-0.5*y3-1;
    inequalityConstrVals(3) = 2*x2+2*y1-y2-0.5*y3-1;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
function [functionValue equalityConstrVals inequalityConstrVals] = tp5(xu, xl)

    %At optima x1=2,x2=0,y1=2,y2=0,fu=3.6,fl=2
    x1 = xu(1);
    x2 = xu(2);
    y1 = xl(1);
    y2 = xl(2);
        
    r = 0.1;
    x = [x1 x2]';
    y = [y1 y2]';
    
    functionValue = r*x'*x - 3*y1 - 4*y2 + 0.5*y'*y;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Write the constraints here
    equalityConstrVals = [];
    %inequalityConstrVals = [];
    %Lower level constraints included at upper level
    inequalityConstrVals(1) = -0.333*y1 + y2 - 2;
    inequalityConstrVals(2) = y1 - 0.333*y2 -2;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
 function [functionValue equalityConstrVals inequalityConstrVals] = tp6(xu, xl)

    %At optima x1=1.888,y1=0.888,y2=0,fu=1.2098,fl=-7.61
    x1 = xu(1);
    y1 = xl(1);
    y2 = xl(2);

    functionValue = (x1-1).^2 + 2*y1 - 2*x1;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Write the constraints here
    equalityConstrVals = [];
    %inequalityConstrVals = [];
    %Lower level constraints included at upper level
    inequalityConstrVals(1) = 4*x1+5*y1+4*y2-12;
    inequalityConstrVals(2) = 4*y2-4*x1-5*y1+4;
    inequalityConstrVals(3) = 4*x1-4*y1+5*y2-4;
    inequalityConstrVals(4) = 4*y1-4*x1+5*y2-4;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
function [functionValue equalityConstrVals inequalityConstrVals] = tp7(xu, xl)

    %At optima x1=5.24,x2=5.63,y1=5.24,y2=0,y3=0.27,fu=2.0714,fl=-2.0714
    x1 = xu(1);
    x2 = xu(2);
    y1 = xl(1);
    y2 = xl(2);

    functionValue = -(x1+y1).*(x2+y2)./(1+x1.*y1+x2.*y2);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Write the constraints here
    equalityConstrVals = [];
    inequalityConstrVals(1) = x1.^2+x2.^2 - 100;
    inequalityConstrVals(2) = x1-x2; %New constraint added at upper level to correct the bilevel problem
    %Lower level constraints included at upper level
    inequalityConstrVals(3) = y1-x1;
    inequalityConstrVals(4) = y2-x2;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
function [functionValue equalityConstrVals inequalityConstrVals] = tp8(xu, xl)

    %At optima x1=0,x2=30,y1=-10,y2=10,fu=0,fl=-100
    x1 = xu(1);
    x2 = xu(2);
    y1 = xl(1);
    y2 = xl(2);
    
    functionValue = abs(2*x1+2*x2-3*y1-3*y2-60);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Write the constraints here
    equalityConstrVals = [];
    inequalityConstrVals(1) = x1+x2+y1-2*y2-40;
    %Lower level constraints included at upper level
    inequalityConstrVals(2) = 2*y1-x1+10;
    inequalityConstrVals(3) = 2*y2-x2+10;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [functionValue equalityConstrVals inequalityConstrVals] = tp9(xu, xl)

    %At optima x1=0,x2=30,y1=-10,y2=10,fu=0,fl=-100
    x = xu;
    y = xl;
    
    functionValue = sum(abs(x-1))+sum(abs(y));
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Write the constraints here
    equalityConstrVals = [];
    inequalityConstrVals = [];
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [functionValue equalityConstrVals inequalityConstrVals] = tp10(xu, xl)

    %At optima x1=0,x2=30,y1=-10,y2=10,fu=0,fl=-100
    x = xu;
    y = xl;
    
    functionValue = sum(abs(x-1))+sum(abs(y));
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Write the constraints here
    equalityConstrVals = [];
    inequalityConstrVals = [];
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%